package szalak;

public class Chat {

    private boolean flag = false;

    public synchronized void question(String msg) {
        if (this.flag) {
            try {
                wait();
            } catch (InterruptedException ie) {
                ie.printStackTrace();
            }
        }
        System.out.println(msg);
        this.flag = true;
        notify();
    }

    public synchronized void answer(String msg) {
        if (!this.flag) {
            try {
                wait();
            } catch (InterruptedException ie) {
                ie.printStackTrace();
            }
        }
        System.out.println(msg);
        this.flag = false;
        notify();
    }

    static class T1 implements Runnable {

        private final static String[] QUESTIONS = {"Hi", "How are you?", "I am also doing fine"}; 

        private Chat c;

        public T1(Chat c) {
            this.c = c;
            new Thread(this, "Question").start(); 
        }

        @Override
        public void run() {
            for (String question : QUESTIONS) {
                this.c.question(question);
            }
        }
    }

    static class T2 implements Runnable {

        private final static String[] ANSWERS = {"Hi", "I am good, what about you?", "Great!"}; 

        private Chat c;

        public T2(Chat c) {
            this.c = c;
            new Thread(this, "Answer").start(); 
        }

        @Override
        public void run() {
            for (String answer : ANSWERS) {
                this.c.answer(answer);
            }
        }
    }

    @SuppressWarnings("unused")
    public static void main(String[] args) {
        Chat chat = new Chat();
        new T1(chat);
        new T2(chat);
    }

}
