package szalak;



public class DeadlockSolution {

    protected static Object lock1 = new Object();

    protected static Object lock2 = new Object();

    static class ThreadDemo1 extends Thread {

        // ordering is lock1 and lock2
        @Override
        public void run() {
            synchronized (lock1) {
                System.out.println("Thread1: holding lock1..."); 
                try {
                    Thread.sleep(10);
                } catch (InterruptedException ie) {
                    ie.printStackTrace();
                }
                System.out.println("Thread1: waiting for lock2..."); 
                synchronized (lock2) {
                    System.out.println("Thread1: Holding lock1 & lock2..."); 
                }
            }
            System.out.println("Thread1: run finished"); 
        }
    }

    static class ThreadDemo2 extends Thread {

        // correct ordering is lock1 and lock2
        @Override
        public void run() {
            synchronized (lock1) {
                System.out.println("Thread2: holding lock1..."); 
                try {
                    Thread.sleep(10);
                } catch (InterruptedException ie) {
                    ie.printStackTrace();
                }
                System.out.println("Thread2: waiting for lock2..."); 
                synchronized (lock2) {
                    System.out.println("Thread2: Holding lock1 & lock2..."); 
                }
            }
            System.out.println("Thread2: run finished"); 
        }
    }

    public static void main(String[] args) {
        ThreadDemo1 thd1 = new ThreadDemo1();
        ThreadDemo2 thd2 = new ThreadDemo2();
        thd1.start();
        thd2.start();
    }

}
