package szalak;

public class JoinDemo {

    static class Counter extends Thread {

        private int limit;
        private int sleepTime;

        public Counter(String name, int limit, int sleepTime) {
            super(name);
            this.limit = limit;
            this.sleepTime = sleepTime;
        }

        @Override
        public void run() {
            try {
                for (int i = 0; i < this.limit; i++) {
                    System.out.printf("%s:%d\n", getName(), Integer.valueOf(i)); 
                    Thread.sleep(this.sleepTime);
                }
            } catch (InterruptedException ie) {
                ie.printStackTrace();
            }
        }
    }

    public static void start() {
        Counter thd1 = new Counter("T1", 50, 100); 
        Counter thd2 = new Counter("T2", 40, 90); 
        thd1.start();
        thd2.start();
        // if you completely comments this try/catch section, the start finished message displayed immediately after threads are starting
        // if you comments only one thdx.join(), the start finished message displayed after a thread which is waiting for join finished
        try {
            thd1.join();
            thd2.join();
        } catch (InterruptedException ie) {
            ie.printStackTrace();
        }
        System.out.println("Start finished"); 
    }

    public static void main(String[] args) {
        start();
    }

}
