package szalak;

public class SynchronizedDemo extends Thread {

    private final static String MESSAGE[] = {
        "The", "meaning", "of", "life", "is", "42" 
    };

    static class SynchronizedOutput {

        // if the 'synchronized' keyword is removed, the message
        // is displayed in random fashion
        public static synchronized void displayList(String name, String list[]) {
            for (String string : list) {
                SynchronizedDemo t = (SynchronizedDemo) Thread.currentThread();
                t.randomWait();
                System.out.println(name + string);
            }
        }
    }

    public SynchronizedDemo(String id) {
        super(id);
    }

    @SuppressWarnings({"static-method", "static-access"})
    protected void randomWait() {
        try {
            Thread.currentThread().sleep((long) (Math.random() * 300));
        } catch (InterruptedException ie) {
            System.out.println("Thread interrupted"); 
        }
    }

    @Override
    public void run() {
        SynchronizedOutput.displayList(getName(), MESSAGE);
    }

    public static void main(String[] args) {
        SynchronizedDemo thread1 = new SynchronizedDemo("thread1:"); 
        SynchronizedDemo thread2 = new SynchronizedDemo("thread2:"); 
        thread1.start();
        thread2.start();
        boolean t1IsAlive = true;
        boolean t2IsAlive = true;
        do {
            if (t1IsAlive && !thread1.isAlive()) {
                t1IsAlive = false;
                System.out.println("t1 is dead"); 
            }
            if (t2IsAlive && !thread2.isAlive()) {
                t2IsAlive = false;
                System.out.println("t2 is dead"); 
            }
        } while (t1IsAlive || t2IsAlive);
    }

}
